﻿/**
* swarm Version 1 by Peter Organa. Jan, 08, 2008
* Visit http://blog.organa.ca for documentation, updates and more free code.
*
*
* Copyright (c) 2008 Peter Organa
* 
* Permission is hereby granted, free of charge, to any person
* obtaining a copy of this software and associated documentation
* files (the "Software"), to deal in the Software without
* restriction, including without limitation the rights to use,
* copy, modify, merge, publish, distribute, sublicense, and/or sell
* copies of the Software, and to permit persons to whom the
* Software is furnished to do so, subject to the following
* conditions:
* 
* The above copyright notice and this permission notice shall be
* included in all copies or substantial portions of the Software.
* 
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
* EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
* OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
* NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
* HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
* WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
* FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
* OTHER DEALINGS IN THE SOFTWARE.
*/
package ca.organa {
	import flash.display.MovieClip;
	import ca.organa.entity;
	import flash.events.Event;
	import flash.geom.Point;
	import ca.organa.obstacle;
	public class entityManager extends MovieClip {		
		private var entityContainer:Object = new Object();
		private var entityID:int = 0;
		private var obstacleID:int = 0;
		private var entitySearchArray:Array;
		private var swarmAmount:int = 80;
		private var obstacleAmount:int = 1;
		private const SCREEN_WIDTH:Number = 500;
		private const SCREEN_HEIGHT:Number = 500;
		public function entityManager() {
			var i:int;
			for (i = 0; i < obstacleAmount; i++) {
				addObstacle();
			}
			for (i = 0; i <swarmAmount; i++) {
				addEntity();
			}

			addEventListener(Event.ENTER_FRAME, enterFrameHandler);
		}
		private function enterFrameHandler(evt:Event):void {
			entitySearchArray = new Array();
			//
			var animateGuy:entity;
			var headingPoint:Point
			var closestObject:Object;
			for (var s:String in entityContainer) {				
				if (entityContainer[s] is entity) {
					animateGuy = entityContainer[s];	
					headingPoint = new Point(this.mouseX, this.mouseY);							
					closestObject = findClosest(animateGuy);
					animateGuy.closeEntity = closestObject.closestEntity;
					animateGuy.closeObstacle = closestObject.closestObstacle;
					animateGuy.heading = headingPoint;
					animateGuy.callUpdate();
				}
				///Place code to animate the entity.
			}
		}
		private function findClosest(findSource:baseEntity):Object {
			var returnList:Object = new Object();
			var closestEntityDistance:Number = Infinity;
			var closestObstacleDistance:Number = Infinity;
			returnList.closestEntity = null;
			returnList.closestObstacle = null; 
			for (var s:String in entityContainer) {			
				var checkAgainst:baseEntity = entityContainer[s];
				if (checkAgainst != findSource) {
					var dx:Number = checkAgainst.x - findSource.x;
					var dy:Number = checkAgainst.y - findSource.y;
					var dist:Number = dx * dx + dy * dy - checkAgainst.size*checkAgainst.size;
					if (checkAgainst is entity && dist < closestEntityDistance) {
						closestEntityDistance = dist;
						returnList.closestEntity = checkAgainst;
					}
					if (checkAgainst is obstacle && dist < closestObstacleDistance) {
						closestObstacleDistance = dist;
						returnList.closestObstacle = checkAgainst;
					}
				}
			}
			return returnList;
		}
		private function addObstacle():obstacle {
			var createObstacle:obstacle = new obstacle(obstacleID);	
			entityContainer["obstacle_" + obstacleID] = createObstacle;
			obstacleID++;
			addChild(createObstacle);
			createObstacle.x = Math.random() * SCREEN_WIDTH;
			createObstacle.y = Math.random() * SCREEN_HEIGHT;
			return createObstacle;
		}
		private function addEntity():entity {
			var createElement:entity = new entity(entityID);
			entityContainer["entity_" + entityID] = createElement;
			entityID++;
			addChild(createElement);
			createElement.x = Math.random()*SCREEN_WIDTH;
			createElement.y = Math.random()*SCREEN_HEIGHT;
			return createElement;
		}
	}
}